#if !defined(AFX_CHECKSGRIDSTATIC1153_H__C6B79C3F_85BE_4711_A709_59C9349C2802__INCLUDED_)
#define AFX_CHECKSGRIDSTATIC1153_H__C6B79C3F_85BE_4711_A709_59C9349C2802__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ChecksGridStatic1153.h : header file
//

#include "mirror_UsualIncludes1153.h"

/////////////////////////////////////////////////////////////////////////////
// CChecksGridStatic1153 window
class CChecksGridStatic1153 : public CStatic
{
private:
	enum
	{
		TrackTimerID=1000,
		TrackTimerTime=100
	};

public:
	enum modes_CChecksGridStatic1153
	{
		mode_None					=	__b16(0x0000000000000000),	// 
		mode_OneSameBitOfSomeBytes	=	__b16(0x0000000000000001),	//   .
																	//   m_qwBitMask, 
																	// -  ,  - m_wBytesStep
		mode_Align_X0_toCellWidth	=	__b16(0x0000000000000010),	//   X0    
		/////////////////
		mode_init					=	mode_OneSameBitOfSomeBytes|mode_Align_X0_toCellWidth,
		//
	};


//  

public:
	enum max_values
	{
		maxv_ChecksMax=3000,//DWORD
		maxv_ChecksToShowX=16,
		maxv_ChecksToShowY=1,
	};

private:
	enum main_values
	{
		/*
		mxv_ChecksMax=256,//WORD
		def_TextEscapeFromLeft=4,
		def_TrackLineWid=1,
		def_MinRowHeight=2,
		def_MaxRowHeight=100,
*/
		
		iniv_BkColor=RGB(255,255,255),
		iniv_LineColor=RGB(170,170,170),
		iniv_CheckColor=RGB(0,0,0),
		iniv_CheckWid=25,
		iniv_CheckHig=18,
		iniv_Checks=36,
		sizeof_bitsArray	=	(maxv_ChecksMax/8+(maxv_ChecksMax%8?1:0)),
	};



/*
	 
****
maxv_EditsMax
sizeof_bitsArray
****
*/




	enum min_values
	{
		/*
		mxv_ChecksMax=256,//WORD
		mx_MinCheckWidth=12,
		def_TextEscapeFromLeft=4,
		def_TrackLineWid=1,
		def_MinRowHeight=2,
		def_MaxRowHeight=100,

		def_cell_W=14,
		def_cell_H=14
		*/
	};


public:
	//  
	enum mess
	{
		UserChangedData=WM_USER+200,
//		IDmess_OnCellChange,
	};

	bool m_bShowBeginFromZero;

private:
	WORD m_wMarkedCell_nzb;//  (0 -  )


	WORD m_wFlags;//, 
	int m_nX0;// 
	int m_nY0;// 


//	int m_nX0_rigbut;
	
	int m_nCheckWid;
	int m_nCheckHig;
	
	WORD m_wCheckTracked_nzb;
//	bool m_bWasShiftWhenTrack;

	bool m_bControlSizeCorrected;
	bool m_bFontCorrected;
	CFont m_font;
	bool m_bEnableNotifyParent;

	BYTE m_a_byDataBitsArray[sizeof_bitsArray]; //  (    -     ) -   = ( -> )
	BYTE m_a_byDisableBitsArray[sizeof_bitsArray]; //
//	DWORD m_dwdData32_disabled;
	WORD m_wChecks;

//	WORD m_wCheckWidth;
	DWORD m_dwdBkColor;
	DWORD m_dwdLineColor;
	DWORD m_dwdCheckColor;
//	bool m_bMarkAllSquare;


///////////////////////////////////////////////////
///////////////////////////////////////////////////
public:
	const BYTE* Get_m_a_byDataBitsArray();

	void SetCheckNum(WORD wNum);
	WORD GetCheckNum();
//	DWORD GetData32();
//	void SetCheckData32(DWORD dwdData32);
//	void SetCheckDisable32(DWORD dwdDis32);

	void SetCheckDisable(const BYTE* pBitArray,WORD wLenInChecks,bool bInvert,bool bShadowOnly);
	bool GetCheckDisabled(WORD wCheckNum_zb_leftbeginonscreen);
	void SetCheckDisable(WORD wCheckNum_zb_leftbeginonscreen,bool bDisable);
	BYTE GetDataOneBit(WORD wCheckNum_zb_leftbeginonscreen);
	void SetDataOneBit(WORD wCheckNum_zb_leftbeginonscreen,bool bData);
//	void SetScrollPosInPerCents(BYTE byPerCent);
	void SetScrollPosInPerCents(double dPerCent);

//	bool ConvertCheckNumToBytePosAndMask(WORD wCheckNum_zb_leftbeginonscreen,bool bData);

	CChecksGridStatic1153();
	virtual ~CChecksGridStatic1153();
	BOOL Create(CWnd* pParent);
	bool GetEnableNotifyParent();
	void SetEnableNotifyParent(bool b);
	bool GetCheckFromPoint(CPoint point, WORD* pwCheck);
//	void SetRadioCheckMode(bool bIsRadio,bool bIsNum,bool bIsAlonePosForCheckRow,bool bIsVertical);
	void DataToHex_Bits(BYTE* pHexArr,DWORD/*MAP32*/ map32HexArrLen,DWORD/*MAP32*/ map32BegAddr,WORD wStep,BYTE byMask,bool bWriteToHexMap);
//	void DataFromHex_Bits(BYTE* pHexArr,WORD wHexArrLen, WORD wStep,BYTE byMask);

///////////////////////////////////////////////////
///////////////////////////////////////////////////
private:
	void SendNotifyMessToParent(int nID);
	void PaintElement(CDC* dc,long ldcW,long ldcH);

///////////////////////////////////////////////////
///////////////////////////////////////////////////
public:
	void SetAllBitsTo1();
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CChecksGridStatic1153)
	public:
	protected:
	//}}AFX_VIRTUAL


protected:
	//{{AFX_MSG(CChecksGridStatic1153)
	afx_msg void OnPaint();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnDestroy();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg UINT OnGetDlgCode();
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnKillFocus(CWnd* pNewWnd);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CHECKSGRIDSTATIC1153_H__C6B79C3F_85BE_4711_A709_59C9349C2802__INCLUDED_)
