// ChecksGridStatic1153.cpp : implementation file
//

#include "stdafx.h"
#include "ChecksGridStatic1153.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

BEGIN_MESSAGE_MAP(CChecksGridStatic1153, CStatic)
	//{{AFX_MSG_MAP(CChecksGridStatic1153)
	ON_WM_PAINT()
	ON_WM_ERASEBKGND()
	ON_WM_DESTROY()
	ON_WM_LBUTTONDOWN()
	ON_WM_GETDLGCODE()
	ON_WM_MOUSEMOVE()
	ON_WM_TIMER()
	ON_WM_MOUSEWHEEL()
	ON_WM_RBUTTONDOWN()
	ON_WM_KEYDOWN()
	ON_WM_KEYUP()
	ON_WM_KILLFOCUS()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChecksGridStatic1153 message handlers
//
CChecksGridStatic1153::CChecksGridStatic1153()
{
	m_bShowBeginFromZero=false;
//	m_bWasShiftWhenTrack=false;
	m_wMarkedCell_nzb=0;

//	m_nX0_rigbut=0;
	m_nX0=0;
	m_nY0=0;
	m_wFlags=mode_init/*PR_DEFAULT*/;
//	m_bMarkAllSquare=true;
	m_wCheckTracked_nzb=0;
	m_bEnableNotifyParent=true;

	memset(m_a_byDataBitsArray,0,sizeof(m_a_byDataBitsArray));
	memset(m_a_byDisableBitsArray,0,sizeof(m_a_byDisableBitsArray));


	m_nCheckWid=iniv_CheckWid;
	m_nCheckHig=iniv_CheckHig;
	m_wChecks=1/*iniv_Checks*/;

//	m_wCheckWidth=init_CheckWidth;
	m_dwdBkColor=iniv_BkColor;
	m_dwdLineColor=iniv_LineColor;
	m_dwdCheckColor=iniv_CheckColor;

	m_bFontCorrected=false;
	m_bControlSizeCorrected=false;

}



//  
BOOL CChecksGridStatic1153::OnEraseBkgnd(CDC* pDC){return TRUE;}

// ,    
bool CChecksGridStatic1153::GetEnableNotifyParent()
{
	return m_bEnableNotifyParent;
}

//  
void CChecksGridStatic1153::SetEnableNotifyParent(bool b)
{
	m_bEnableNotifyParent=b;
}

// 
BOOL CChecksGridStatic1153::Create(CWnd* pParent)
{
	if(pParent && !m_hWnd)
	{
		RECT r={0,0,0,0};
		return CStatic::Create(0,0,r,pParent);
	}

	if(m_hWnd)
	{
		CRect r;
		GetClientRect(r);
		m_nCheckHig=r.Height();
		m_nCheckWid=r.Width();


		OnPaint();//  

		return 1;
	}
	else
	{
		return 0;
	}
}


UINT CChecksGridStatic1153::OnGetDlgCode() 
{
	//return DLGC_WANTALLKEYS;
	return CStatic::OnGetDlgCode();
}




//     
void CChecksGridStatic1153::SendNotifyMessToParent(int nID)
{
	CWnd* w=GetParent();
	if(w && m_bEnableNotifyParent)
	{
		w->SendMessage
		(
			WM_COMMAND,
			(WPARAM)( ((nID&0x0000ffff)<<16) | (GetDlgCtrlID()&0x0000ffff) ),
			(LPARAM)GetSafeHwnd()
		);
	}
}

void CChecksGridStatic1153::OnMouseMove(UINT nFlags, CPoint point) 
{
	/*
	if(nFlags&MK_RBUTTON)
	{
		m_nX0=point.x;
		//m_nY0=point.y;
	}
	*/

	/*
	if(m_wMarkedCell_nzb)
	{
		SetFocus();
	}
	*/


//	m_bWasShiftWhenTrack=false;



	if(GetCheckFromPoint(point,&m_wCheckTracked_nzb))
	{
		/*
		if(nFlags&MK_SHIFT)
		{
			m_bWasShiftWhenTrack=true;
		}
		*/
		
		//SetTimer(TimerID,TimerTime,0);
	}
	else
	{
		m_wCheckTracked_nzb=0;
	}
	Invalidate(0);

	CStatic::OnMouseMove(nFlags, point);
}



//     
bool CChecksGridStatic1153::GetCheckFromPoint(CPoint point, WORD* pwCheck)
{
	if(pwCheck)*pwCheck=0;

	point.x-=m_nX0;
	point.y-=m_nY0;

	CRect PlotterRect;
	GetClientRect(&PlotterRect);
	if(m_nCheckWid<=0 || m_nCheckHig<=0)return false;


	//     PlotterRect
//	if(point.x<=0||point.x>=PlotterRect.right ||point.y<=0||point.y>=PlotterRect.bottom)return false;

	if(point.x<=0 ||point.y<=0)return false;
	if(point.x>=m_wChecks*m_nCheckWid || point.y>1*m_nCheckHig)return false;


	WORD wChBefore;
	float fCheckPart;

	//,    
	wChBefore=(WORD)(point.x/m_nCheckWid);

	//   
	fCheckPart=((float)(point.x-wChBefore*m_nCheckWid+1))/m_nCheckWid;

	//   10% -    
	if(fCheckPart-0.1<=0 || fCheckPart+0.1>=1)return false;

	*pwCheck=wChBefore+1;
	return true;
}


void CChecksGridStatic1153::SetCheckDisable(const BYTE* pBitArray,WORD wLenInChecks,bool bInvert,bool bShadowOnly)
{
	if(wLenInChecks>m_wChecks)wLenInChecks=m_wChecks;
	WORD wLenBytes=(wLenInChecks>>3)+((wLenInChecks&7)?1:0);
	if(wLenBytes>/*sizeof_bitsArray*/maxv_ChecksMax)return;

	BYTE by;
	for(WORD w=0;w<wLenBytes;w++)
	{
		if(bInvert)
		{
			by=~pBitArray[w];
		}
		else
		{
			by=pBitArray[w];
		}

		if(bShadowOnly)
		{
			m_a_byDisableBitsArray[w]|=by;
		}
		else
		{
			m_a_byDisableBitsArray[w]=by;
		}

	}
/*
	if(bInvert)
	{
	}
	memmove(m_a_byDisableBitsArray,pBitArray,wLenBytes);
*/
		//	bShadowOnly
	Invalidate(0);
}


void CChecksGridStatic1153::SetCheckDisable(WORD wCheckNum_zb_leftbeginonscreen,bool bDisable)
{

//	if(wCheckNum_zb_leftbeginonscreen>m_wChecks)
	/*
	DWORD dwd,dwdDis32_before;
	dwdDis32_before=m_dwdData32_disabled;

//	if(m_byChecks==0)m_byChecks=1;
//	if(m_byChecks>def_ChecksMax)m_byChecks=def_ChecksMax;
	if(m_wFlags&PR_RADIO)
	{
		m_dwdData32_disabled=dwdDis32;
	}
	else
	{
		if(m_wFlags&PR_TOPLEFTCHECKHIGHBIT)
		{
			m_dwdData32_disabled=0;
			// 
			for(dwd=0;dwd<((DWORD)m_byChecks);dwd++)
			{
				m_dwdData32_disabled<<=1;
				if(dwdDis32&1)m_dwdData32_disabled|=1;
				dwdDis32>>=1;
			}
		}
		else
		{
			m_dwdData32_disabled=dwdDis32;
		}
	}

	if(m_dwdData32_disabled!=dwdDis32_before)Invalidate(0);
	//Invalidate(0);
	*/
}

BYTE CChecksGridStatic1153::GetDataOneBit(WORD wCheckNum_zb_leftbeginonscreen)
{
	if(wCheckNum_zb_leftbeginonscreen>=m_wChecks)return 0;

	BYTE bymask;
	if(wCheckNum_zb_leftbeginonscreen)
	{
		bymask=(0x80>>(wCheckNum_zb_leftbeginonscreen&0x7));
	}
	else
	{
		bymask=0x80;
	}

	return (m_a_byDataBitsArray[(wCheckNum_zb_leftbeginonscreen&~0x7)>>3]&bymask);
}


//CorrectCheckNum(DWORD dwdMaxValue)
void CChecksGridStatic1153::SetCheckNum(WORD wNum)
{
	if(m_wChecks!=wNum)
	{
		if(!wNum)wNum=1;
		if(wNum>maxv_ChecksMax)wNum=maxv_ChecksMax;
		m_bControlSizeCorrected=false;
		m_wChecks=wNum;
		Invalidate(0);
	}
}



//  
void CChecksGridStatic1153::OnPaint() 
{
	CPaintDC dcReal(this);

	if(!m_bFontCorrected)
	{
		m_bFontCorrected=true;
		LOGFONT lf;
		if(GetFont()->GetLogFont(&lf))
		{
			m_font.CreateFontIndirect(&lf);
			//SetFont(&m_font,0);
		}
	}

	//  
	//    
	long ldcW,ldcH;
	CRect PlotterRect;
	GetClientRect(&PlotterRect);

	ldcW=PlotterRect.Width();
	ldcH=PlotterRect.Height();
	if(ldcW<0)ldcW=0;
	if(ldcH<0)ldcH=0;

	//    
	CDC dcPlotter;CBitmap bmpMem;
	dcPlotter.CreateCompatibleDC(&dcReal);
	bmpMem.CreateCompatibleBitmap(&dcReal,ldcW,ldcH);
	//    
	CBitmap *oldbmpMem=dcPlotter.SelectObject(&bmpMem);
	PaintElement(&dcPlotter,ldcW,ldcH);// 
	//   (dcPlotter)   (dcReal)
	dcReal.BitBlt(0,0,ldcW,ldcH,&dcPlotter,0,0,SRCCOPY);
	//    
	dcPlotter.SelectObject(oldbmpMem);
	bmpMem.DeleteObject();
	ReleaseDC(&dcPlotter);

/*
	//  
	//    
	long ldcW,ldcH;
	long ldcWtoShow,ldcHtoShow;
//	CRect PlotterRect;
//	GetClientRect(&PlotterRect);
//	ldcW=PlotterRect.Width();
//	ldcH=PlotterRect.Height();

	ldcW=m_nCheckWid*max(m_byChecks,1);//
	ldcH=m_nCheckHig*1;//
	
	ldcWtoShow=min(m_nCheckWid*maxv_ChecksToShowX,ldcW);
	ldcHtoShow=min(m_nCheckHig*maxv_ChecksToShowY,ldcH);
//	if(ldcW<0)ldcW=0;
//	if(ldcH<0)ldcH=0;

	//    
	CDC dcPlotter;CBitmap bmpMem;
	dcPlotter.CreateCompatibleDC(&dcReal);
	bmpMem.CreateCompatibleBitmap(&dcReal,ldcW,ldcH);
	//    
	CBitmap *oldbmpMem=dcPlotter.SelectObject(&bmpMem);

	PaintElement(&dcPlotter,ldcW,ldcH);// 
	//   (dcPlotter)   (dcReal)
	//  m_nX0  m_nY0
//	dcReal.BitBlt(0,0,ldcW,ldcH,&dcPlotter,0,0,SRCCOPY);

	dcReal.FillSolidRect(0,0,ldcW,ldcH,_sysgreycolor);

	dcReal.BitBlt(0,0,ldcWtoShow,ldcHtoShow,&dcPlotter,-m_nX0,-m_nY0,SRCCOPY);

	//    
	dcPlotter.SelectObject(oldbmpMem);
	bmpMem.DeleteObject();
	ReleaseDC(&dcPlotter);
	*/
}

void CChecksGridStatic1153::PaintElement(CDC *dc,long ldcW,long ldcH)
{
	if(!m_wChecks)
	{
		dc->FillSolidRect(0,0,ldcW,ldcH,RGB(255,0,0));
		return;
	}
	else
	{
		dc->FillSolidRect(0,0,ldcW,ldcH,_sysgreycolor);
	}
//	m_dwdData32=0x0100;

	WORD ci;
	RECT cl_r;


	if(!m_bControlSizeCorrected)
	{
//		POINT pnt;
		GetClientRect(&cl_r);

		//     
		//byChckTrckd_nzb=0;
//		GetCursorPos(&pnt);
//		ScreenToClient(&pnt);


		//  
		long cl_rWID;
		long cl_rHIG;

		cl_rWID=cl_r.right-cl_r.left+1;
		cl_rHIG=cl_r.bottom-cl_r.top+1;

		long needClWID;
		long needClHIG;
/*
		m_nCheckWid=cl_rWID/maxv_ChecksToShowX;

		needClWID=m_nCheckWid*min(m_wChecks,maxv_ChecksToShowX);
*/

		m_nCheckWid= cl_rWID/min( max(m_wChecks,1) ,maxv_ChecksToShowX);


		needClWID=m_nCheckWid*min(m_wChecks,maxv_ChecksToShowX);





		needClHIG=cl_rHIG;//m_nCheckHig*1;

		if(cl_rWID!=needClWID || cl_rHIG!=needClHIG)
		{
			//,   
			WINDOWPLACEMENT wpm;
			RECT& wr=wpm.rcNormalPosition;
			GetWindowPlacement(&wpm);
			wr.right=wr.right-(cl_rWID-(cl_r.left+needClWID-1))+1;
			wr.bottom=wr.bottom-(cl_rHIG-(cl_r.top+needClHIG-1))+1;
			MoveWindow(&wr,1);
			Invalidate(0);
		}
		m_bControlSizeCorrected=true;

		GetParent()->Invalidate(1);
	}




//	dc->FillSolidRect(0,0,ldcW,ldcH,::GetSysColor(COLOR_BTNFACE));

//	dc->SetTextColor(RGB(128,0,0));

	CPen LinePen(PS_SOLID,0,::GetSysColor(COLOR_BTNSHADOW));
	CPen *oldPen=oldPen=dc->SelectObject(&LinePen);
	CFont* oldFont=dc->SelectObject(&m_font);

	
	// 
	CString txt;


//	DWORD dwdchk=m_dwdData32;
//	DWORD dwdchk_dis=m_dwdData32_disabled;

	RECT chkRect={m_nX0,m_nY0,m_nX0+m_nCheckWid,m_nY0+m_nCheckHig};
	RECT chkRect2=chkRect;
//	chkRect2.bottom++;
//	chkRect2.top++;
	chkRect2.left++;
	chkRect2.right++;

	//  (    -     ) -   = ( -> )
	BYTE *pbyData=m_a_byDataBitsArray-1;
	BYTE *pbyDisabl=m_a_byDisableBitsArray-1;
	BYTE byDataMask=0;


	bool bStyleDisabled=((GetStyle()&WS_DISABLED))!=0;

	dc->SetTextColor(RGB(0,0,255));
	dc->SetBkMode(TRANSPARENT);
	BYTE byPreviousBit=1;

	for(ci=0;ci<m_wChecks;ci++)
	{
		if(ci>=sizeof_bitsArray*8)break;
		if(!(byDataMask>>=1))
		{
			byDataMask=0x80;
			pbyData++;
			pbyDisabl++;
		}


		if(((*pbyDisabl)&byDataMask) || bStyleDisabled)
		{
			dc->FillSolidRect(&chkRect,_sysgreycolor);// 
		}
		else
		{
			//dc->FillSolidRect(&chkRect,RGB(0,255,0));
			/*
			if(m_wCheckTracked_nzb==ci+1 )
			{
				dc->FillSolidRect(&chkRect,RGB(168,211,255));
				SetTimer(TrackTimerID,TrackTimerTime,0);
			}
			else
			{
				dc->FillSolidRect(&chkRect,m_dwdBkColor);// 
			}
*/



			if(m_wCheckTracked_nzb==ci+1 )
			{
				//

				if(m_wMarkedCell_nzb)
				{
					dc->FillSolidRect(&chkRect,RGB(255,128,64));
				}
				else
				{
					dc->FillSolidRect(&chkRect,RGB(168,211,255));
				}

				SetTimer(TrackTimerID,TrackTimerTime,0);
			}
			else
			{
				// 
				dc->FillSolidRect(&chkRect,m_dwdBkColor);// 
			}

			if(m_wMarkedCell_nzb==ci+1)
			{
				//
				dc->FillSolidRect(&chkRect,RGB(255,128,64));
				//SetTimer(TrackTimerID,TrackTimerTime,0);
			}			



			if(((*pbyData)&byDataMask) /*|| 1*/)
			{
				if(!byPreviousBit)
				{
					dc->SetTextColor(RGB(0,0,255));
					byPreviousBit=1;
				}
//				dc->SetTextColor(RGB(0,0,255));

				//RECT r=chkRect;
//				RECT r2;//=chkRect.+;
				//r.left--;
				//r.bottom--;

				txt.Format("%d",ci+(m_bShowBeginFromZero?0:1));

//				dc->DrawText(txt,&r,DT_CENTER|DT_SINGLELINE|DT_VCENTER);
				dc->DrawText(txt,&chkRect,DT_CENTER|DT_SINGLELINE|DT_VCENTER);
				dc->DrawText(txt,&chkRect2,DT_CENTER|DT_SINGLELINE|DT_VCENTER);
			}
			else
			{
				if(byPreviousBit)
				{
					dc->SetTextColor(RGB(180,180,180));
					byPreviousBit=0;
				}
				RECT r=chkRect;
				//r.left--;
				//r.bottom--;
				txt.Format("%d",ci+(m_bShowBeginFromZero?0:1));
				dc->DrawText(txt,&r,DT_CENTER|DT_SINGLELINE|/*DT_VCENTER*/DT_BOTTOM);

			}
		}
/*
		// 
		if(dwdchk&1)
		{
		}
*/
		
		chkRect.left+=m_nCheckWid;
		chkRect.right+=m_nCheckWid;

		chkRect2.left+=m_nCheckWid;
		chkRect2.right+=m_nCheckWid;

		if(chkRect.left>=ldcW)break;

	}




	long CurrX=m_nX0+m_nCheckWid;
	long CurrY=m_nY0+m_nCheckHig;
	//  
	for(ci=1;ci<m_wChecks;ci++,CurrX+=m_nCheckWid)
	{
		if(CurrX>ldcW)break;

		dc->MoveTo(CurrX,m_nY0);
		dc->LineTo(CurrX,m_nCheckHig);

	}



	//  
	dc->SelectObject(oldPen);
	dc->SelectObject(oldFont);

  
}





BOOL CChecksGridStatic1153::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt) 
{
	return CStatic::OnMouseWheel(nFlags, zDelta, pt);
}

void CChecksGridStatic1153::SetScrollPosInPerCents(double dPerCent)
{
	if(dPerCent>100.0)dPerCent=100;
	int nMax=(m_wChecks-1)*m_nCheckWid;
	m_nX0= (int)( (nMax*dPerCent)/100.0 );

	// -      
	if(chkFlg(m_wFlags,mode_Align_X0_toCellWidth))
	{
		m_nX0= -(m_nX0-(m_nX0%m_nCheckWid));
	}
	else
	{
		m_nX0=-m_nX0;
	}

	Invalidate(0);
}

// -  ,      
CChecksGridStatic1153::~CChecksGridStatic1153()
{
	if(m_hWnd)
	{
		DestroyWindow();
	}
}

void CChecksGridStatic1153::OnDestroy() 
{
	KillTimer(TrackTimerID);

	CStatic::OnDestroy();
}

const BYTE* CChecksGridStatic1153::Get_m_a_byDataBitsArray()
{
	return m_a_byDataBitsArray;
}



bool CChecksGridStatic1153::GetCheckDisabled(WORD wCheckNum_zb_leftbeginonscreen)
{
	if(wCheckNum_zb_leftbeginonscreen>=m_wChecks)return false;

	BYTE bymask;
	if(wCheckNum_zb_leftbeginonscreen)
	{
		bymask=(0x80>>(wCheckNum_zb_leftbeginonscreen&0x7));
	}
	else
	{
		bymask=0x80;
	}

	return ((m_a_byDisableBitsArray[(wCheckNum_zb_leftbeginonscreen&~0x7)>>3]&bymask)!=0);
}


WORD CChecksGridStatic1153::GetCheckNum()
{
	return m_wChecks;
}



//  
void CChecksGridStatic1153::OnLButtonDown(UINT nFlags, CPoint point)
{
	SetFocus();


/*	if((nFlags&MK_RBUTTON))
	{
		//     ()
	}
	else
	{
		// 
		m_wMarkedCell_nzb=0;
	}
	*/
//	if(nFlags!=MK_LBUTTON)return;

	//,    
	WORD wCheck;
	if(GetCheckFromPoint(point,&wCheck) && wCheck>0 && wCheck<=maxv_ChecksMax)
	{
		// -  
		if((GetStyle()&WS_DISABLED) || GetCheckDisabled(wCheck-1))
		{
		}
		else
		{
			//      

			//   
			if(!(nFlags&MK_RBUTTON))
			{
				// 
				SetDataOneBit(wCheck-1,GetDataOneBit(wCheck-1)?false:true);
				// 
				m_wMarkedCell_nzb=0;
			}

			//  
			if((nFlags&MK_RBUTTON))
			{
				if(!m_wMarkedCell_nzb)
				{
					// 
					m_wMarkedCell_nzb=wCheck;

					// 
					SetDataOneBit(wCheck-1,GetDataOneBit(wCheck-1)?false:true);
				}
				else
				{
					// 

					if(m_wMarkedCell_nzb==wCheck)
					{
						// 
						SetDataOneBit(wCheck-1,GetDataOneBit(wCheck-1)?false:true);

					}
					else
					{
						//
						WORD wbeg_nzb;
						WORD wend_nzb;

						if(wCheck>m_wMarkedCell_nzb)
						{
							wbeg_nzb=m_wMarkedCell_nzb;
							wend_nzb=wCheck;
						}
						else
						{
							wbeg_nzb=wCheck;
							wend_nzb=m_wMarkedCell_nzb;
						}

						for(WORD w_nzb=wbeg_nzb;w_nzb<=wend_nzb;w_nzb++)
						{
							if((GetStyle()&WS_DISABLED) || GetCheckDisabled(w_nzb-1))
							{
							}
							else
							{
								SetDataOneBit(w_nzb-1,GetDataOneBit(m_wMarkedCell_nzb-1)?true:false);
							}
						}

						m_wMarkedCell_nzb=0;
						//Invalidate(0);
						//SendNotifyMessToParent(UserChangedData);
					}
				}

				SendNotifyMessToParent(UserChangedData);
				Invalidate(0);
				return;
			}








			SendNotifyMessToParent(UserChangedData);
			Invalidate(0);
		}
	}
}

void CChecksGridStatic1153::OnRButtonDown(UINT nFlags, CPoint point) 
{
	SetFocus();
	OnLButtonDown(nFlags,point);
/*
	//,    
	WORD wCheck;
	if(GetCheckFromPoint(point,&wCheck) && wCheck>0 && wCheck<=maxv_ChecksMax)
	{
		// -  
		if((GetStyle()&WS_DISABLED) || GetCheckDisabled(wCheck-1))
		{
		}
		else
		{
			if(m_wMarkedCell_nzb)
			{
				//  
				if(m_wMarkedCell_nzb!=wCheck)
				{
					//
					WORD wbeg_nzb;
					WORD wend_nzb;

					if(wCheck>m_wMarkedCell_nzb)
					{
						wbeg_nzb=m_wMarkedCell_nzb;
						wend_nzb=wCheck;
					}
					else
					{
						wbeg_nzb=wCheck;
						wend_nzb=m_wMarkedCell_nzb;
					}

					for(WORD w_nzb=wbeg_nzb;w_nzb<=wend_nzb;w_nzb++)
					{
						//if((GetStyle()&WS_DISABLED) || GetCheckDisabled(w_nzb-1))
						//{
						//}
						//else
						{
							if(nFlags&MK_SHIFT)
							{
								// 
								SetDataOneBit(w_nzb-1,false);
							}
							else
							{	
								// 
								SetDataOneBit(w_nzb-1,true);
							}
						}
					}

					// 
					//m_wMarkedCell_nzb
					m_wMarkedCell_nzb=0;
					Invalidate(0);
					SendNotifyMessToParent(UserChangedData);
				}
				else
				{
					// 
					m_wMarkedCell_nzb=0;
				}

				Invalidate(0);
			}
			else
			{
				//   
					// 
					//m_wMarkedCell_nzb
					m_wMarkedCell_nzb=wCheck;
					//SendNotifyMessToParent(UserChangedData);

				Invalidate(0);

			}




		}
	}

*/
	CStatic::OnRButtonDown(nFlags, point);
}

void CChecksGridStatic1153::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	/*
	if(nChar==VK_SHIFT)
	{
		if(m_wMarkedCell_nzb && !m_bWasShiftWhenTrack)
		{
			m_bWasShiftWhenTrack=true;
			Invalidate(0);
		}
	}
	*/

	CStatic::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CChecksGridStatic1153::OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	/*
	if(nChar==VK_SHIFT)
	{
		if(
			//m_wMarkedCell_nzb && !
			m_bWasShiftWhenTrack)
		{
			m_bWasShiftWhenTrack=false;
			Invalidate(0);
		}
	}
*/
	
	CStatic::OnKeyUp(nChar, nRepCnt, nFlags);
}

void CChecksGridStatic1153::OnKillFocus(CWnd* pNewWnd) 
{
	if(m_wMarkedCell_nzb)
	{
		m_wMarkedCell_nzb=0;
		Invalidate(0);
	}

	CStatic::OnKillFocus(pNewWnd);
	
	// TODO: Add your message handler code here
	
}

void CChecksGridStatic1153::SetDataOneBit(WORD wCheckNum_zb_leftbeginonscreen,bool bData)
{
	if(wCheckNum_zb_leftbeginonscreen>=m_wChecks)return;

	BYTE bymask;

	if(wCheckNum_zb_leftbeginonscreen)
	{
		bymask=(0x80>>(wCheckNum_zb_leftbeginonscreen&0x7));
	}
	else
	{
		bymask=0x80;
	}

	if(bData)
	{
		m_a_byDataBitsArray[(wCheckNum_zb_leftbeginonscreen&~0x7)>>3]|=bymask;
	}
	else
	{
		m_a_byDataBitsArray[(wCheckNum_zb_leftbeginonscreen&~0x7)>>3]&=~bymask;
	}
}

void CChecksGridStatic1153::SetAllBitsTo1()
{
	BYTE *pbyData=m_a_byDataBitsArray-1;
	WORD wDataCurrByteForControl=0;
	BYTE byDataMask=0;

	WORD wCheck_zb=0;
	//m_wChecks

	for(wCheck_zb=0;wCheck_zb<m_wChecks;wCheck_zb++)
	{
		if(wDataCurrByteForControl>=maxv_ChecksMax)break;
		if(!(byDataMask>>=1))
		{
			byDataMask=0x80;
			pbyData++;
		}

		(*pbyData)|=byDataMask;
	}

	SendNotifyMessToParent(UserChangedData);
}

//    .      
// -   
void CChecksGridStatic1153::DataToHex_Bits(
		BYTE* pHexArr,
		DWORD/*MAP32*/ map32HexArrLen,
		DWORD/*MAP32*/ map32BegAddr,
		WORD wStep,
		BYTE byMask,
		bool bWriteToHexMap)
{
	if(!pHexArr || !map32HexArrLen)return;

	switch(byMask)
	{
		default:return;
		case _b8(0x00000001):
		case _b8(0x00000010):
		case _b8(0x00000100):
		case _b8(0x00001000):
		case _b8(0x00010000):
		case _b8(0x00100000):
		case _b8(0x01000000):
		case _b8(0x10000000):
			break;
	}

	BYTE *pbyData=m_a_byDataBitsArray-1;
	//WORD wDataCurrByteForControl=0;
	DWORD/*MAP32*/ map32DataCurrByteForControl=0;
	BYTE byDataMask=0;


	BYTE* pHexArrLastByte_nzb=pHexArr+map32HexArrLen;

	for(BYTE* pby=pHexArr+map32BegAddr;pby<pHexArrLastByte_nzb;pby+=wStep,map32DataCurrByteForControl++)
	{
		if(map32DataCurrByteForControl>=maxv_ChecksMax)break;
		if(!(byDataMask>>=1))
		{
			byDataMask=0x80;
			pbyData++;
		}

		if(!bWriteToHexMap)
		{
			if(((*pby)&byMask))
			{
				*pbyData|=byDataMask;
			}
			else
			{
				*pbyData&=~byDataMask;
			}
		}
		else
		{
			if(((*pbyData)&byDataMask))
			{
				*pby|=byMask;
			}
			else
			{
				*pby&=~byMask;
			}
		}
	}

}



void CChecksGridStatic1153::OnTimer(UINT nIDEvent) 
{
	if(nIDEvent==TrackTimerID)
	{
		KillTimer(TrackTimerID);

		//,  
		POINT pnt;
		if(GetCursorPos(&pnt))
		{
			if(WindowFromPoint(pnt)!=this)
			{
				m_wCheckTracked_nzb=0;
			}
		}
		Invalidate(0);
	}

	CStatic::OnTimer(nIDEvent);
}

